<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('年份')" prop="year">
        <el-input
          v-model="queryParams.year"
          :placeholder="$t('请输入') + $t('年份')"
          clearable
          size="small"
          @input="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['ehs:ehskpinew:add']"
        >{{ $t('新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['ehs:ehskpinew:edit']"
        >{{ $t('修改') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['ehs:ehskpinew:remove']"
        >{{ $t('删除') }}</el-button>
      </el-col>
      <!--<el-col :span="1.5">
          <el-button
                  type="info"
                  icon="el-icon-upload2"
                  size="mini"
                  @click="handleImport"
                  v-hasPermi="['ehs:ehskpinew:edit']"
          >{{ $t('导入') }}</el-button>
      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['ehs:ehskpinew:export']"
        >{{ $t('导出') }}</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="ehskpinewList" @selection-change="handleSelectionChange" :cell-class-name="tableCellClassName" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column :label="$t('年份')" align="center" prop="year" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('装置名称')" align="center" prop="plants" :formatter="plantsFormat" />
      <el-table-column :label="$t('kpi名称')" align="center" prop="kpiname" :formatter="kpinameFormat" />
      <el-table-column :label="$t('kpi英文名')" align="center" prop="kpinameen" :formatter="kpinameenFormat" />
      <el-table-column :label="$t('第一季度')" align="center" prop="spring" :show-overflow-tooltip="true">
        <template slot-scope="scope" v-if="scope.row.spring != null">
          <el-dropdown placement="bottom" trigger="click">
            <span class="el-dropdown-link">
              <span>{{scope.row.spring}}</span>
              <i class="el-icon-caret-bottom"></i>
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item @click.native="statusFinish(1, scope.row)">{{ $t('已完成') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusCare(1, scope.row)">{{ $t('注意') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusUrgent(1, scope.row)">{{ $t('紧急') }}</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
      <el-table-column :label="$t('第二季度')" align="center" prop="summer" :show-overflow-tooltip="true">
        <template slot-scope="scope" v-if="scope.row.summer != null">
          <el-dropdown placement="bottom" trigger="click">
            <span class="el-dropdown-link">
              <span>{{scope.row.summer}}</span>
              <i class="el-icon-caret-bottom"></i>
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item @click.native="statusFinish(2, scope.row)">{{ $t('已完成') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusCare(2, scope.row)">{{ $t('注意') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusUrgent(2, scope.row)">{{ $t('紧急') }}</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
      <el-table-column :label="$t('第三季度')" align="center" prop="autumn" :show-overflow-tooltip="true">
        <template slot-scope="scope" v-if="scope.row.autumn != null">
          <el-dropdown placement="bottom" trigger="click">
            <span class="el-dropdown-link">
              <span>{{scope.row.autumn}}</span>
              <i class="el-icon-caret-bottom"></i>
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item @click.native="statusFinish(3, scope.row)">{{ $t('已完成') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusCare(3, scope.row)">{{ $t('注意') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusUrgent(3, scope.row)">{{ $t('紧急') }}</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
      <el-table-column :label="$t('第四季度')" align="center" prop="winter" :show-overflow-tooltip="true">
        <template slot-scope="scope" v-if="scope.row.winter != null">
          <el-dropdown placement="bottom" trigger="click">
            <span class="el-dropdown-link">
              <span>{{scope.row.winter}}</span>
              <i class="el-icon-caret-bottom"></i>
            </span>
            <el-dropdown-menu slot="dropdown" class="el-dropdown-change">
              <el-dropdown-item @click.native="statusFinish(4, scope.row)">{{ $t('已完成') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusCare(4, scope.row)">{{ $t('注意') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusUrgent(4, scope.row)">{{ $t('紧急') }}</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
      <el-table-column :label="$t('全年')" align="center" prop="annual" :show-overflow-tooltip="true">
        <template slot-scope="scope" v-if="scope.row.annual != null">
          <el-dropdown placement="bottom" trigger="click">
            <span class="el-dropdown-link">
              <span>{{scope.row.annual}}</span>
              <i class="el-icon-caret-bottom"></i>
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item @click.native="statusFinish(5, scope.row)">{{ $t('已完成') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusCare(5, scope.row)">{{ $t('注意') }}</el-dropdown-item>
              <el-dropdown-item @click.native="statusUrgent(5, scope.row)">{{ $t('紧急') }}</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
      <el-table-column :label="$t('备注')" align="center" prop="remarks" :show-overflow-tooltip="true"/>
      <el-table-column :label="$t('操作')" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['ehs:ehskpinew:edit']"
          >{{ $t('修改') }}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['ehs:ehskpinew:remove']"
          >{{ $t('删除') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改KPI统计及格对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('装置名称')" prop="plants">
          <el-select v-model="form.plants" :placeholder="$t('请选择') + $t('装置名称')">
            <el-option
              v-for="dict in plantsOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('年份')" prop="year">
          <el-input v-model="form.year" :placeholder="$t('请输入') + $t('年份')" />
        </el-form-item>
        <el-form-item :label="$t('kpi名称')" prop="kpiname">
          <el-select v-model="form.kpiname" :placeholder="$t('请选择') + $t('kpi名称')">
            <el-option
              v-for="dict in kpinameOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('kpi英文名')" prop="kpinameen">
          <el-select v-model="form.kpinameen" :placeholder="$t('请选择') + $t('kpi英文名')">
            <el-option
              v-for="dict in kpinameenOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('第一季度')" prop="spring">
          <el-input v-model="form.spring" :placeholder="$t('请输入') + $t('第一季度')" />
        </el-form-item>
        <el-form-item :label="$t('第二季度')" prop="summer">
          <el-input v-model="form.summer" :placeholder="$t('请输入') + $t('第二季度')" />
        </el-form-item>
        <el-form-item :label="$t('第三季度')" prop="autumn">
          <el-input v-model="form.autumn" :placeholder="$t('请输入') + $t('第三季度')" />
        </el-form-item>
        <el-form-item :label="$t('第四季度')" prop="winter">
          <el-input v-model="form.winter" :placeholder="$t('请输入') + $t('第四季度')" />
        </el-form-item>
        <el-form-item :label="$t('全年')" prop="annual">
          <el-input v-model="form.annual" :placeholder="$t('请输入') + $t('全年')" />
        </el-form-item>
        <el-form-item :label="$t('备注')" prop="remarks">
          <el-input v-model="form.remarks" :placeholder="$t('请输入') + $t('备注')" />
        </el-form-item>
          <el-form-item :label="$t('归属部门')" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" :placeholder="$t('请选择') + $t('归属部门')" />
          </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
        <el-upload
                ref="upload"
                :limit="1"
                accept=".xlsx, .xls"
                :headers="upload.headers"
                :action="upload.url + '?updateSupport=' + upload.updateSupport"
                :disabled="upload.isUploading"
                :on-progress="handleFileUploadProgress"
                :on-success="handleFileSuccess"
                :auto-upload="false"
                drag
        >
            <i class="el-icon-upload"></i>
            <div class="el-upload__text">
                {{ $t('将文件拖到此处，或') }}
                <em>{{ $t('点击上传') }}</em>
            </div>
            <div class="el-upload__tip" slot="tip">
                <!--<el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据-->
                <el-link type="info" style="font-size:12px" @click="importTemplate">{{ $t('下载模板') }}</el-link>
            </div>
            <div class="el-upload__tip" style="color:red" slot="tip">{{ $t('提示：仅允许导入“xls”或“xlsx”格式文件！') }}</div>
        </el-upload>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitFileForm">{{ $t('确 定') }}</el-button>
            <el-button @click="upload.open = false">{{ $t('取 消') }}</el-button>
        </div>
    </el-dialog>
  </div>
</template>

<script>
import { listEhskpinew, getEhskpinew, delEhskpinew, addEhskpinew, updateEhskpinew, exportEhskpinew, importTemplate} from "@/api/ehs/ehskpinew";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "Ehskpinew",
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // KPI统计及格表格数据
      ehskpinewList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
      // 装置字典
      plantsOptions: [],
      // kpi名称字典
      kpinameOptions: [],
      // kpi英文名字典
      kpinameenOptions: [],
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/ehs/ehskpinew/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        plants: null,
        year: null,
        kpiname: null,
        kpinameen: null,
        spring: null,
        summer: null,
        autumn: null,
        winter: null,
        annual: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        deptId: [
          { required: true, message: this.$t('部门')  + this.$t('不能为空'), trigger: "blur" }
        ],
      }
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = (document.body.clientHeight - 80) * 0.8
      })
    this.getList();
    this.getTreeselect();
    this.getDicts("PLANTS_DIVIDE").then(response => {
      this.plantsOptions = response.data;
    });
    this.getDicts("KPI_ZHCN_NAME").then(response => {
      this.kpinameOptions = response.data;
    });
    this.getDicts("KPI_ENUS_NAME").then(response => {
      this.kpinameenOptions = response.data;
    });
  },
  methods: {
    /** 查询KPI统计及格列表 */
    getList() {
      this.loading = true;
      listEhskpinew(this.queryParams).then(response => {
        this.ehskpinewList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 装置字典翻译
    plantsFormat(row, column) {
      return this.selectDictLabel(this.plantsOptions, row.plants);
    },
    // kpi名称字典翻译
    kpinameFormat(row, column) {
      return this.selectDictLabel(this.kpinameOptions, row.kpiname);
    },
    // kpi英文名字典翻译
    kpinameenFormat(row, column) {
      return this.selectDictLabel(this.kpinameenOptions, row.kpinameen);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    //根据分数显示颜色提示
    tableCellClassName({ row, column, rowIndex, columnIndex }) {
      if (columnIndex == 5){
        return this.changeColor(row.firstquarterStatus)
      }
      if (columnIndex == 6){
        return this.changeColor(row.secondquarterStatus)
      }
      if (columnIndex == 7){
        return this.changeColor(row.threequarterStatus)
      }
      if (columnIndex == 8){
        return this.changeColor(row.fourquarterStatus)
      }
      if (columnIndex == 9){
        return this.changeColor(row.annualStatus)
      }
    },
    changeColor (value) {
      if (value == 1){
        return 'cellFinish'
      }else if( value == 2) {
        return 'cellCare'
      }else if( value == 3) {
        return 'cellUrgent'
      }
    },
    //变换季度状态
    statusFinish (index, row) {
      this.form = row;
      if (index == 1) {
        this.form.firstquarterStatus = 1;
      }else if (index == 2) {
        this.form.secondquarterStatus = 1;
      }else if (index == 3) {
        this.form.threequarterStatus = 1;
      }else if (index == 4) {
        this.form.fourquarterStatus = 1;
      }else if (index == 5) {
        this.form.annualStatus = 1;
      }
      updateEhskpinew(this.form).then(response => {
        this.msgSuccess(this.$t('修改成功'));
        this.open = false;
        this.getList();
      });
    },
    statusCare (index, row) {
      this.form = row;
      if (index == 1) {
        this.form.firstquarterStatus = 2;
      }else if (index == 2) {
        this.form.secondquarterStatus = 2;
      }else if (index == 3) {
        this.form.threequarterStatus = 2;
      }else if (index == 4) {
        this.form.fourquarterStatus = 2;
      }else if (index == 5) {
        this.form.annualStatus = 2;
      }
      updateEhskpinew(this.form).then(response => {
        this.msgSuccess(this.$t('修改成功'));
        this.open = false;
        this.getList();
      });
    },
    statusUrgent (index, row) {
      this.form = row;
      if (index == 1) {
        this.form.firstquarterStatus = 3;
      }else if (index == 2) {
        this.form.secondquarterStatus = 3;
      }else if (index == 3) {
        this.form.threequarterStatus = 3;
      }else if (index == 4) {
        this.form.fourquarterStatus = 3;
      }else if (index == 5) {
        this.form.annualStatus = 3;
      }
      updateEhskpinew(this.form).then(response => {
        this.msgSuccess(this.$t('修改成功'));
        this.open = false;
        this.getList();
      });
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        plants: null,
        year: null,
        kpiname: null,
        kpinameen: null,
        spring: null,
        summer: null,
        autumn: null,
        winter: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null,
        annual: null,
        firstquarterStatus: null,
        secondquarterStatus: null,
        threequarterStatus: null,
        annualStatus: null,
        fourquarterStatus: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t('新增') + " " + this.$t('KPI统计及格');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getEhskpinew(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('修改') + this.$t('KPI统计及格');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateEhskpinew(this.form).then(response => {
              this.msgSuccess(this.$t('修改成功'));
              this.open = false;
              this.getList();
            });
          } else {
            addEhskpinew(this.form).then(response => {
              this.msgSuccess(this.$t('新增成功'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return delEhskpinew(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess(this.$t('删除成功'));
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm(this.$t('是否确认导出所有KPI统计及格数据项?'), this.$t('警告'), {
          confirmButtonText: this.$t('确定'),
          cancelButtonText: this.$t('取消'),
          type: "warning"
        }).then(function() {
          return exportEhskpinew(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = this.$t('用户导入');
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
        this.upload.open = false;
        this.upload.isUploading = false;
        this.$refs.upload.clearFiles();
        if (response.data[0] != null) {
          this.$alert(this.$t('成功导入') + response.msg + this.$t('条数据') + "，" + this.$t('第') + response.data + this.$t('行数据出现错误导入失败')+"。", this.$t('导入结果'), { dangerouslyUseHTMLString: true });
        }else {
          this.$alert(this.$t('成功导入') + response.msg + this.$t('条数据'), this.$t('导入结果'), { dangerouslyUseHTMLString: true });
        }
        this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      }
  }
};
</script>

<style>
  .el-checkbox, .el-dropdown {
    color: #606266 !important;
  }
</style>

